package dev.shadowsoffire.apotheosis.adventure.loot;

import net.minecraft.client.Minecraft;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.entity.monster.Zombie;
import java.util.IdentityHashMap;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.level.LevelEvent;
import net.minecraft.server.MinecraftServer;
import dev.shadowsoffire.apotheosis.adventure.AdventureModule;
import net.minecraft.world.item.Items;
import net.minecraft.world.entity.LivingEntity;
import java.util.function.Function;
import net.minecraftforge.fml.loading.FMLEnvironment;
import net.minecraftforge.server.ServerLifecycleHooks;
import net.minecraft.world.level.Level;
import java.util.Map;
import net.minecraftforge.fml.common.Mod;
import net.minecraft.world.item.ItemStack;
import java.util.function.Predicate;

@Mod.EventBusSubscriber(modid = "apotheosis", bus = Mod.EventBusSubscriber.Bus.FORGE)
class ShieldBreakerTest implements Predicate<ItemStack>
{
    private static Map<Level, Zombies> zombieCache;
    
    @Override
    public boolean test(final ItemStack t) {
        try {
            final MinecraftServer server = ServerLifecycleHooks.getCurrentServer();
            Level level = null;
            if (server != null) {
                level = (Level)server.m_129880_(Level.f_46428_);
            }
            else if (FMLEnvironment.dist.isClient()) {
                level = Client.getLevel();
            }
            if (level != null) {
                final Zombies zombies = ShieldBreakerTest.zombieCache.computeIfAbsent(level, Zombies::new);
                return t.canDisableShield(zombies.target.m_21206_(), (LivingEntity)zombies.target, (LivingEntity)zombies.attacker);
            }
            return t.canDisableShield(Items.f_42740_.m_7968_(), (LivingEntity)null, (LivingEntity)null);
        }
        catch (final Exception ex) {
            AdventureModule.LOGGER.error("Failed to execute ShieldBreakerTest", (Throwable)ex);
            return false;
        }
    }
    
    @SubscribeEvent
    public static void unload(final LevelEvent.Unload e) {
        ShieldBreakerTest.zombieCache.remove(e.getLevel());
    }
    
    static {
        ShieldBreakerTest.zombieCache = new IdentityHashMap<Level, Zombies>();
    }
    
    record Zombies(Zombie attacker, Zombie target) {
        public Zombies(final Level level) {
            this(new Zombie(level), new Zombie(level));
            this.target.m_21008_(InteractionHand.OFF_HAND, new ItemStack((ItemLike)Items.f_42740_));
        }
    }
    
    private static class Client
    {
        static Level getLevel() {
            return (Level)Minecraft.m_91087_().f_91073_;
        }
    }
}
